<template>
	<view >
		<scroll-view scroll-y class="scroll-Y">
			<view class="square-2">
				<view class="square-title">
					<view class="title-sign"><view class="sign"></view></view>
					<view class="title-text"><text>托盘条码</text></view>
				</view>
				<view class="square-content">
					<view class="content-input">
						<input v-model="barcode" type="text" placeholder="扫码 / 输入" maxlength="8" 
						@input="findBarcode()" :focus="barcodeFocus" @focus="focuss" >
						<uni-icons type="closeempty" size="20" color="#dadada" @click="removeBarcode()"></uni-icons>
					</view>
				</view>
			</view>
			<view class="square-2">
				<view class="square-title">
					<view class="title-sign"><view class="sign"></view></view>
					<view class="title-text"><text>货品条码</text></view>
				</view>
				<view class="square-content">
					<view class="content-input-combox" style="width: 94%;">
						<input style="width: 90%;" type="text" v-model="matnr" placeholder="扫码 / 输入" @input="findMat()":focus="focus"
						 @focus="focuss">
						<!-- @focus="focuss" -->
						<uni-icons type="closeempty" size="20" color="#dadada" @click="removeMatnr()"></uni-icons>
					</view>
				</view>
			</view>
			
			<view class="square-1">
				<view class="square-title">
					<view class="title-sign"><view class="sign"></view></view>
					<view class="title-text"><text>商品列表</text></view>
					<view v-show="matCount > 0" style="display: inline-block;float: right;height: 100rpx;line-height: 100rpx;margin-right: 50rpx;">请扫码选取 {{matCount}} 件商品</view>
				</view>
			</view>
			<view class="square-none" v-show="matList.length === 0">
				<view class="v-show">暂无更多数据. . . </view>
			</view>
			<checkbox-group @change="checkbox">
				<view v-for="(item,index) in matList" :key="index" class="data-list bg-false" :class="'bg-'+item.checked" >
					<view class="data-list-left">
						<view class="matnr" :style="item.color">No:{{listLen-index}}</view>
						<view class="matnr" :style="item.color">{{item.matnr}}-{{item.batch}}</view>
					</view>
					<view class="data-list-right">
						<uni-icons type="trash" size="20" color="#a5a5a5" @click="remove(item,index)"></uni-icons>
					</view>
				</view>
			</checkbox-group>
		</scroll-view>
		<view class="footer flex justify-around">
			<view>
				<button class="cu-btn lg" @click="resst()">重置</button>
			</view>
			<view>
				<button class="cu-btn lg pakin-btn bg-blue" @click="comb()">确认</button>
			</view>
		</view>
		<view>
			<!-- 提示信息弹窗 -->
			<uni-popup ref="message" type="message">
				<uni-popup-message :type="msgType" :message="messageText" :duration="2000"></uni-popup-message>
			</uni-popup>
		</view>
	</view>
</template>

<script>
	import permision from "@/common/permission.js"
	export default {
		data() {
			return {
				commonUrl:null,
				barcode: '',
				barcodeFocus:true,
				focus:false,
				type: 'center',
				searchBox: 'hide',
				pick:'hide',
				matnr:'',
				// matList:[{matnr:'1101842-10000',batch:'22047515999',color:{color:'red'}}],
				matList:[],
				result: '',
				siteList:[],
				staNoList:[],
				satNo:'',
				listLen:0,
				msgType: 'success',
				messageText: '这是一条成功提示',
				fontColor:{color:'red'},
				matCount:'',
				wrkNo:'',
			}
		},
		onReady() {
			setInterval(function(){
				// console.log(this.matList)
				// this.getMatListLen()
			},1000)
		},
		mounted(){
			const UIP = uni.getStorageSync('UIP');
			this.baseIP = UIP;
			const UPORT = uni.getStorageSync('UPORT');
			this.basePORT = UPORT
			const PROJ = uni.getStorageSync('UPROJ');
			this.baseUrl = PROJ
			this.getUrl()
		},
		methods: {
			// 获取url
			getUrl() {
				this.commonUrl = this.baseHttp + this.baseIP + ':' +this.basePORT + "/" +this.baseUrl
			},
			huanghang() {
				this.matnr = ''
				this.focus = false;
				this.$nextTick(function() {
					this.focus = true;
				});
					
			},
			messageToggle(type) {
				this.msgType = type
				this.messageText = `这是一条${type}消息提示`
				this.$refs.message.open()
			},
			getMatListLen() {
				// this.listLen = this.matList.length;
			},
			focuss() {
				// uni.hideKeyboard()
			},
			resst() {
				this.matList = []
				this.barcode = ''
				this.matnr = ''
				this.matCount = ''
				uni.vibrateShort();
			},
			removeBarcode() {
				this.barcode = ''
				uni.vibrateShort();	
				this.barcodeFocus = false;
				this.$nextTick(function() {
					this.barcodeFocus = true;
				});
			},
			removeMatnr() {
				this.matnr = ''
				uni.vibrateShort();
				this.focus = false;
				this.$nextTick(function() {
					this.focus = true;
				});
			},
			remove(item,index) {
				this.matList.splice(index,1);
				this.listLen = this.matList.length
				this.messageToggle('success')
				this.messageText = '删除成功'
				uni.vibrateShort();
			},
			
			selectMat() {
				let that = this
				uni.vibrateShort();
				uni.showLoading();
				uni.navigateTo({
					url: "matSelect",
					events: {
					    // 为指定事件添加一个监听器，获取被打开页面传送到当前页面的数据
					    acceptDataFromOpenedPage: function(data) {
							that.matnr = data.data
							that.findMat(that.matnr)
					    },
					  },
					  success: function(res) {
					    // 通过eventChannel向被打开页面传送数据
					    res.eventChannel.emit('acceptDataFromOpenerPage', {baseIP:that.baseIP, basePORT:that.basePORT })
					  }
				});
				that.matnr = ''
			},
			findBarcode() {
				let that = this
				uni.request({
				    url: that.commonUrl + '/mobile/pakout/confirm/barcode/auth',
				    data: {
						barcode:that.barcode
				    },
				    header: {
						'token':uni.getStorageSync('token'),
				    },
					success(result) {
						console.log(result)
						let res = result.data;
						if (res.code === 200) {
							if (res.data.ioType === 101) {
								that.matList = res.data.list.concat(that.matList)
								that.listLen = that.matList.length;
								return;
							}
							if (res.data.ioType === 103) {
								that.matCount = res.data.list.length
								that.wrkNo = res.data.list[0].wrkNo
								return;
							}
							// if (res.data) {
							// 	that.matCount = res.data.length
							// }
						} else if (res.code === 403) {
							uni.showToast({title: res.msg, icon: "none", position: 'top'})
								setTimeout(() => {
									uni.reLaunch({
										url: '../login/login'
									});
							}, 1000);
						} else {
							uni.showToast({title: res.msg, icon: "none",position: 'top'})
						}
						
					}
				});
				
			},
			findMat() {
				let that = this
				uni.request({
				    url: that.commonUrl + '/mobile/pakout/confirm/pick/auth',
				    data: {
						wrkNo:that.wrkNo,
						matnr:that.matnr
				    },
				    header: {
						'token':uni.getStorageSync('token')
				    },
					success(result) {
						var res = result.data;
						if(res.code === 200 ) {
							if(res.data) {
								if (that.matList.length == 0) {
									that.matList.push(res.data)
									that.listLen = that.matList.length;
									that.huanghang();
									return;
								}
								for(let i = 0;i<that.matList.length;i++) {
									if (that.matList.length < that.matCount){
										if(JSON.stringify(that.matList[i]) === JSON.stringify(res.data)) {
											that.messageToggle('warn');
											that.messageText = '该商品已添加';
											that.huanghang();
											return;
										} else {
											that.matList.unshift(res.data);
											that.listLen = that.matList.length;
											that.huanghang();
											return;
										}
									} else {
										that.messageToggle('warn');
										that.messageText = '已出全部商品，请确认出库';
										that.huanghang();
										return;
									}
								}
							}
						} else if (res.code == 403) {
							uni.showToast({title: res.msg, icon: "none", position: 'top'})
							setTimeout(() => {
								uni.reLaunch({
									url: '../login/login'
								});
							}, 1000);
						} else {
							uni.showToast({title: res.msg, icon: "none",position: 'top'})
						}
						
					}
				});
			},
			comb() {
				let that = this;
				if (that.barcode === '') {
					this.messageToggle('error')
					this.messageText = '请扫描托盘码'
					return;
				}
				if (that.barcode.length !== 8) {
					this.messageToggle('error')
					this.messageText = '托盘码必须为8位'
					return;
				}
				if (that.matList.length === 0) {
					this.messageToggle('error')
					this.messageText = '请添加商品列表'
					return;
				}
				
				if (that.matList.length < that.matCount) {
					var len = that.matCount - that.matList.length
					that.messageToggle('error')
					that.messageText = '还剩' + len + '件未扫描'
					return;
				}
				uni.showLoading();
				uni.request({
				    url: that.commonUrl + '/mobile/pakout/confirm/auth',
				    data: that.matList,
					method: 'POST',
				    header: {
						'token':uni.getStorageSync('token')
				    },
					success(result) {
						uni.showLoading();
						var res = result.data
						if (res.code === 200) {
							uni.showToast({ title: res.msg,position: 'bottom',duration: 1000});
							that.resst();
						} else if (res.code == 403) {
							uni.showToast({title: res.msg, icon: "none", position: 'top'})
							setTimeout(() => {
								uni.reLaunch({
									url: '../login/login'
								});
							}, 1000);
						} else {
							uni.showToast({title: res.msg, icon: "none",position: 'top'})
						}
					}
				});
			},
			getCheckDetl() {   // 获取出库口货物信息
				let that = this
				
			}, // getCheckDetl
			change(e) {
			},
			toggle(type) {
				this.type = type
				// open 方法传入参数 等同在 uni-popup 组件上绑定 type属性
				this.$refs.goodsSearch.open(type)
			},
			checkbox: function (e) {
				var items = this.data,
					values = e.detail.value;
				for (var i = 0, lenI = items.length; i < lenI; ++i) {
					const item = items[i]
					item.id = item.id + ''
					if(values.indexOf(item.id) >= 0){
						this.$set(item,'checked',true)
					}else{
						this.$set(item,'checked',false)
					}
				}
				if (values.length == items.length) {
					this.check = true
					this.checkText = "取消全选"
				} else {
					this.check = false
					this.checkText = "全选"
				}
				uni.vibrateShort();
			},
		}
	}
</script>

<style>
	/* @import "../../colorui/main.css";
	@import "../../colorui/icon.css"; */

	.pak-seach-box {
		background-color: #FFFFFF;
		margin: 15rpx 15rpx 0rpx 15rpx;
		width: 96%;
		height: 150rpx;
		border-radius: 20rpx;
	}
	.box-top{
		display: block;
		height: 60rpx;
		width: 720rpx;
	}
	.color-block-blue {
		background-color: #1E9FFF;
		display: inline-block;
		float: left;
		margin: 15rpx 15rpx 0 15rpx;
		width: 12rpx;
		height: 40rpx;
		border: 5rpx solid #1E9FFF;
		border-radius: 20rpx;
	}
	.title {
		display: inline-block;
		float: left;
		font-size: 34rpx;
		font-weight: 700;
		height: 50rpx;
		line-height: 50rpx;
		margin-top: 10rpx;
	}
	.box-buttom {
		display: inline-block;
		background-color: #f0f0f0;
		width: 65%;
		height: 60rpx;
		border-radius: 20rpx;
		margin: 15rpx 15rpx 0rpx 15rpx;
	}
	.box-buttom input {
		width: 75%;
		float: left;
		margin: 8rpx 10rpx 0rpx 25rpx;
	}
	.box-buttom .search-icon{
		width: 60rpx;
		height: 60rpx;
		float: right;
		margin-top: 5rpx;
		margin-right: 10rpx;
	}
	
	/* .pak-seach-box input {
		background-color: #ededed;
		border: 1rpx solid #d8d8d8;
		display: inline-block;
		border-radius: 20rpx;
		float: left;
		width: 70%;
		height: 60rpx;
		line-height: 60rpx;
		margin: 15rpx 15rpx 0rpx 15rpx;
		padding-left: 20rpx;
	} */
	.pak-seach-box button {
		background-color: #1E9FFF;
		color: #ffffff;
		display: inline-block;
		float: right;
		width: 180rpx;
		height: 60rpx;
		margin: 15rpx 15rpx 0rpx 15rpx;
		line-height: 60rpx;
	}
	.pakin-btn {
		background-color: #1E9FFF;
	}
	.pak-data-box {
		background-color: #F1F1F1;
		margin: 15rpx 15rpx 0rpx 15rpx;
		width: 96%;
		height: 70rpx;
		border-radius: 20rpx;
	}
	.pak-data-box .box-top {
		background-color: #FFFFFF;
		height: 70rpx;
		border-radius: 20rpx 20rpx 20rpx 20rpx;
	}
	.bg-false {
		background-color: #FFFFFF;
	}
	.bg-true {
		background-color: #ebebeb;
	}
	.data-list {
		border-bottom: 1px solid #d8d8d8;
		height: 130rpx;
		margin: 15rpx;
		border-radius: 20rpx;
	}
	.data-list:first-child {
		margin-top: 20rpx;
	}
	.data-list:last-child {
		margin-bottom: 200rpx;
	}
	/* .data-list-left {
		display: inline-block;
		float: left;
		text-align: center;
		width: 100rpx;
		height: 180rpx;
		line-height: 180rpx;
	} */
	.data-list-left {
		width: 550rpx;
		/* background-color: #007AFF; */
		display: inline-block;
		float: left;
		margin-left: 4%;
		height: 130rpx;
		color: #676767;
	}
	.matnr {
		display: inline-block;
		width: 100%;
		font-size: 14px;
		font-weight: 700;
		padding-top: 15rpx;
		/* height: 130rpx;
		line-height: 130rpx; */
	}
	.data-list-right {
		/* background-color: #6739B6; */
		display: inline-block;
		float: right;
		width: 100rpx;
		height: 130rpx;
		line-height: 130rpx;
	}
</style>